Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.jboss.remoting
Class ClientInvoker

    java.lang.Object
      org.jboss.remoting.AbstractInvoker
          org.jboss.remoting.ClientInvoker

All Implemented Interfaces:
  Invoker

public abstract class ClientInvoker
extends AbstractInvoker

ClientInvoker is an abstract client part handler that implements the bulk of the heavy lefting to process a remote method and dispatch it to a remote ServerInvoker and handle the result.

The ClientInvoker in particular handles the loading of remote classes necessary for execution of invocations, as well as the remote loading of remote classes necessary to unmarshal the results or parameters of a result returned from a ServerInvoker.

Specialized Client/Server Invokers might add additional functionality as part of the invocation - such as delivering queued notifcations from a remote server by adding the notification objects during each invocation to the invocation result payload and then having the client re-dispatch the notifications locally upon receiving the return invocation result.

Version:
  $Revision: 1.10 $
Author:
  Jeff Haynie

Field Summary
`protected boolean` | `connected`
`protected InvokerLocator` | `localServerLocator`

Fields inherited from class org.jboss.remoting.AbstractInvoker
`classbyteloader, locator, log, logExtra`

Constructor Summary
`ClientInvoker(ClassLoader cl, InvokerLocator locator)`

Method Summary
`void` | `connect()` connect to the remote invoker
`void` | `disconnect()` disconnect from the remote invokere
`protected void` | `finalize()` Called by the garbage collector on an object when garbage collection determines that there are no more references to the object.
`InvokerLocator` | `getClientLocator()` Gets the client locator.
`protected abstract void` | `handleConnect()` subclasses must implement this method to provide a hook to connect to the remote server, if this applies to the specific transport.
`protected abstract void` | `handleDisconnect()` subclasses must implement this method to provide a hook to disconnect from the remote server, if this applies to the specific transport.
`Object` | `invoke(InvocationRequest in)` transport a request against a remote ServerInvoker
`boolean` | `isConnected()` subclasses must provide this method to return true if their remote connection is connected and false if disconnected.
`protected void` | `postProcess(String sessionId, Object param, Map sendPayload, Map receivedPayload)` this method is called prior to returning the result for the invocation to allow the subclass the ability to modify the result result
`protected void` | `preProcess(String sessionId, Object param, Map sendPayload, Map receivedPayload)` this method is called prior to making the remote invocation to allow the subclass the ability to provide additional data or modify the invocation
`void` | `setClientLocator(InvokerLocator locator)` This should be set when want to override the default behavior of automatically getting s suitable locator.
`protected abstract byte[]` | `transport(String sessionId, byte[] buffer)` called to transport the marshalled invocation to the remote destination, and receive back the marshalled invocation bytes back.

Methods inherited from class org.jboss.remoting.AbstractInvoker
`addClass, getClassBytes, getLocator, loadClass, read, setClassLoader, unmarshal`

Methods inherited from class java.lang.Object
`clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### connected

    protected boolean connected

### localServerLocator

    protected InvokerLocator localServerLocator

Constructor Detail

### ClientInvoker

    public ClientInvoker(ClassLoader cl,
                         InvokerLocator locator)

Method Detail

### setClientLocator

    public void setClientLocator(InvokerLocator locator)

  This should be set when want to override the default behavior of automatically getting s suitable locator. This should be used want want to control what type of callbacks to receive (pull or push). Set to null to poll for callback messages. This can also be used to receive callbacks using another transport and subsystem, if desired.

  Overrides:
    `setClientLocator` in class `AbstractInvoker`
  Parameters:
    `locator` -

### getClientLocator

    public InvokerLocator getClientLocator()

  Gets the client locator. This locator will be used by the server side to make callbacks to the handler for this locator.

  Overrides:
    `getClientLocator` in class `AbstractInvoker`
  Returns:

### invoke

    public Object invoke(InvocationRequest in)
                  throws Throwable

  transport a request against a remote ServerInvoker

  Parameters:
    `in` -
  Returns:
  Throws:
    `Throwable`

### preProcess

    protected void preProcess(String sessionId,
                              Object param,
                              Map sendPayload,
                              Map receivedPayload)

  this method is called prior to making the remote invocation to allow the subclass the ability to provide additional data or modify the invocation

  Parameters:
    `sessionId` -
    `param` -
    `sendPayload` -
    `receivedPayload` -

### postProcess

    protected void postProcess(String sessionId,
                               Object param,
                               Map sendPayload,
                               Map receivedPayload)

  this method is called prior to returning the result for the invocation to allow the subclass the ability to modify the result result

  Parameters:
    `sessionId` -
    `param` -
    `sendPayload` -
    `receivedPayload` -

### transport

    protected abstract byte[] transport(String sessionId,
                                        byte[] buffer)
                                 throws IOException,
                                        ConnectionFailedException

  called to transport the marshalled invocation to the remote destination, and receive back the marshalled invocation bytes back. this method allows the subclass to provide the specific mechanism, protocol, etc. for delivering and returning remote invocations in a transport-specific way.

  Parameters:
    `sessionId` - session id to pass along
    `buffer` - buffer of the serialized method invocation to send to the server
  Returns:
    result of the method invocation as serialized bytes
  Throws:
    `IOException` - fatal exception should only be raised in the case the transport write fails (but is still a valid connection)
    `ConnectionFailedException` - this exception is raised in the case the remote side is no longer available

### isConnected

    public boolean isConnected()

  subclasses must provide this method to return true if their remote connection is connected and false if disconnected. in some transports, such as SOAP, this method may always return true, since the remote connectivity is done on demand and not kept persistent like other transports (such as socket-based transport).

  Returns:
    boolean true if connected, false if not

### connect

    public void connect()
                 throws ConnectionFailedException

  connect to the remote invoker

  Throws:
    `ConnectionFailedException`

### handleConnect

    protected abstract void handleConnect()
                                   throws ConnectionFailedException

  subclasses must implement this method to provide a hook to connect to the remote server, if this applies to the specific transport. However, in some transport implementations, this may not make must difference since the connection is not persistent among invocations, such as SOAP. In these cases, the method should silently return without any processing.

  Throws:
    `ConnectionFailedException`

### handleDisconnect

    protected abstract void handleDisconnect()

  subclasses must implement this method to provide a hook to disconnect from the remote server, if this applies to the specific transport. However, in some transport implementations, this may not make must difference since the connection is not persistent among invocations, such as SOAP. In these cases, the method should silently return without any processing.

### disconnect

    public void disconnect()

  disconnect from the remote invokere

### finalize

    protected void finalize()
                     throws Throwable

  Called by the garbage collector on an object when garbage collection determines that there are no more references to the object. A subclass overrides the `finalize` method to dispose of system resources or to perform other cleanup.

  The general contract of `finalize` is that it is invoked if and when the JavaTM virtual machine has determined that there is no longer any means by which this object can be accessed by any thread that has not yet died, except as a result of an action taken by the finalization of some other object or class which is ready to be finalized. The `finalize` method may take any action, including making this object available again to other threads; the usual purpose of `finalize`, however, is to perform cleanup actions before the object is irrevocably discarded. For example, the finalize method for an object that represents an input/output connection might perform explicit I/O transactions to break the connection before the object is permanently discarded.

  The `finalize` method of class `Object` performs no special action; it simply returns normally. Subclasses of `Object` may override this definition.

  The Java programming language does not guarantee which thread will transport the `finalize` method for any given object. It is guaranteed, however, that the thread that invokes finalize will not be holding any user-visible synchronization locks when finalize is invoked. If an uncaught exception is thrown by the finalize method, the exception is ignored and finalization of that object terminates.

  After the `finalize` method has been invoked for an object, no further action is taken until the Java virtual machine has again determined that there is no longer any means by which this object can be accessed by any thread that has not yet died, including possible actions by other objects or classes which are ready to be finalized, at which point the object may be discarded.

  The `finalize` method is never invoked more than once by a Java virtual machine for any given object.

  Any exception thrown by the `finalize` method causes the finalization of this object to be halted, but is otherwise ignored.

  Throws:
    `Throwable` - the `Exception` raised by this method

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2002 JBoss Group, LLC. All Rights Reserved.